//*****************************************************************************
//	
//	Copyright 2011 by WinSystems Inc.
//
//	Permission is hereby granted to the purchaser of WinSystems GPIO cards 
//	and CPU products incorporating a GPIO device, to distribute any binary 
//	file or files compiled using this source code directly or in any work 
//	derived by the user from this file. In no case may the source code, 
//	original or derived from this file, be distributed to any third party 
//	except by explicit permission of WinSystems. This file is distributed 
//	on an "As-is" basis and no warranty as to performance or fitness of pur-
//	poses is expressed or implied. In no case shall WinSystems be liable for 
//	any direct or indirect loss or damage, real or consequential resulting 
//	from the usage of this source code. It is the user's sole responsibility 
//	to determine fitness for any considered purpose.
//
//*****************************************************************************
//
//	Name	 : pcmvdxpwm.h
//
//	Project	 : PCM-VDX PWM Linux Driver
//
//	Author	 : Paul DeMetrotion
//
//*****************************************************************************
//
//	  Date		Revision	                Description
//	--------	--------	---------------------------------------------
//	05/12/11	  1.00		Original Release
//
//*****************************************************************************

#define PWM_10MHZ 0
#define PWM_50MHZ 1

// south bridge config registers
#define PWM_CTRL 0xD0

// pwm i/o offsets
#define PWM_INT_MSK 0x0
#define PWM_INT_STAT 0x4
#define PWM_SYNC_STAT 0x8
#define PWM_0_PLS_LO 0xC
#define PWM_0_PLS_HI 0x10
#define PWM_0_CTRL 0x14

// PWM Control Register
#define PWM_ENBL 0x80000000L
#define PWM_CONT_MODE 0x40000000L
#define PWM_INVERSE 0x20000000L

#define IOCTL_NUM 'i'

// waveform structure
unsigned long wform[4];

#ifndef CHARDEV_H
  #define CHARDEV_H

#include <linux/ioctl.h> 

//
//#define IOCTL_ENAB_PWM _IOW(IOCTL_NUM, 1, struct wform_def *)
#define IOCTL_ENAB_PWM _IOW(IOCTL_NUM, 1, unsigned long *)

// 
#define IOCTL_ENAB_PWM_RC _IOW(IOCTL_NUM, 2, unsigned long *)

// 
#define IOCTL_DISAB_PWM _IOW(IOCTL_NUM, 3, int)

// 
#define	IOCTL_ENAB_PWM_INT _IOW(IOCTL_NUM, 4, int)

// 
#define	IOCTL_DISAB_PWM_INT	_IOW(IOCTL_NUM, 5, int)

// 
#define	IOCTL_CLR_PWM_INT _IOW(IOCTL_NUM, 6, int)

// 
#define	IOCTL_GET_PWM_INT _IOR(IOCTL_NUM, 7, int)

// 
#define	IOCTL_WAIT_PWM_INT _IOR(IOCTL_NUM, 8, int)

// 
#define	IOCTL_PWM_CLK_SEL _IOW(IOCTL_NUM, 9, int)

// 
#define DEVICE_FILE_NAME "/dev/pcmvdxpwm"

#endif

// function calls
int ioctl_enab_pwm(int channel, unsigned long low, unsigned long high);
int ioctl_enab_pwm_rc(int channel, unsigned long low, unsigned long high, unsigned long repeat);
int ioctl_disab_pwm(int channel);
int ioctl_enab_pwm_int(int channel);
int ioctl_disab_pwm_int(int channel);
int ioctl_clr_pwm_int(int channel);
int ioctl_get_pwm_int(void);
int ioctl_wait_pwm_int(void);
int ioctl_pwm_clk_sel(int clk);
